// aadata2html.js  -- convert aadata file to html

main();

function main()
{
    if(WScript.Arguments.length == 0) {
        WScript.Echo("t@Cw肳Ă܂B");
        WScript.Quit(0);
    }

    var i;
    var argc = WScript.Arguments.length;
    for(i = 0; i < argc; i++) {
        conv_file(WScript.Arguments(i));
    }
}

function conv_file(infname)
{
    var ForReading = 1;
    var ForWriting = 2;
    var TristateUseDefault = -2;
    var fso = WScript.CreateObject("Scripting.FileSystemObject");

    var outfname = infname + ".html";

    if(! fso.FileExists(infname)) {
        WScript.Echo("t@C݂܂:", infname);
        return;
    }
    var infile = fso.OpenTextFile(infname, ForReading, false,
                                  TristateUseDefault);
    var data = read_aadatafile(infile);
    infile.Close();

    if(fso.FileExists(outfname)) {
        WScript.Echo("t@Cɑ݂܂:", outfname);
        return;
    }
    var outfile = fso.OpenTextFile(outfname, ForWriting, true,
                                   TristateUseDefault);
    write_htmlfile(outfile, data, fso.GetBaseName(infname));
    outfile.Close();
}

function read_aadatafile(file)
{
    var line, context = 0, cur;
    var data = new Array();

    while(! file.AtEndOfStream) {
        line = file.ReadLine();

        if(context == 0) {
            if(line.match(/^\[MojieName=.*\]$/)) {
                context = 1;
                cur = new Array();
            }
        }
        else {
            if(line == "[END]") {
                data.push(cur.join("<br>"));
                cur = null;
                context = 0;
            }
            else {
                cur.push(escape_ltgt(line));
            }
        }
    }

    return data;
}

function write_htmlfile(file, data, title)
{
    var header =
        [
            '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"',
            '       "http://www.w3.org/TR/html4/strict.dtd">',
            '<html><head>',
            '<meta http-equiv="content-type" content="text/html; charset=Shift_JIS" />',
            '<title>' + title + '</title>',
            '<script type="text/javascript">',
            'function init() {',
            '    var waitfor = 1000;',
            '    var autostart = false;',
            '    var loop = false;',
            '    document.getElementById("aadatapanel").appendChild(',
            '      create_aadataplayer(data, waitfor, autostart, loop));',
            '}',
            'window.onload = init;',
            '</script>',
            '<style type="text/css">',
            '.oppanel {',
            '  font: 16px "lr oSVbN";',
            '  width: 800px;',
            '  background: #f0f0f0;',
            '  padding-top: 0.5em; ',
            '  border: solid 1px #e0e0e0;',
            '}',
            '.buttonbar {',
            '  padding: 0.5em',
            '}',
            '.buttonbar .button {',
            '  width: 3em;',
            '  height: 2em;',
            '  background: #f0f0f0;',
            '  border: solid 3px #e0e0e0;',
            '  margin: 0.2em;',
            '  padding: 0.2em;',
            '  cursor: default;',
            '}',
            '.buttonbar .pressed {',
            '  border: inset 3px #e0e0e0',
            '}',
            '.buttonbar .step {',
            '  width: 6em;',
            '  text-align: right;',
            '  background: #f0f0f0;',
            '  border: none;',
            '  padding: 0.5em',
            '}',
            '.buttonbar .speedval {',
            '  width: 6em;',
            '  text-align: right;',
            '  background: #f0f0f0;',
            '  border: none;',
            '  padding: 0.5em',
            '}',
            '.buttonbar .loop {',
            '  padding: 0.5em',
            '}',
            '.progressbar {',
            '  height: 1em;',
            '  border: solid 1px #e0e0e0;',
            '  background: #ffffff;',
            '  margin: 0.5em;',
            '}',
            '.progressbar .filler {',
            '  background: #aaaaaa;',
            '  height: 100%;',
            '}',
            '.txtpanel {',
            '  font: 16px "lr oSVbN";',
            '  line-height: 18px;',
            '  white-space: nowrap;',
            '  color: #000000;',
            '  margin: 0.5em;',
            '}',
            '.datasrc {',
            '  display: none;',
            '}',
            '</style>',
            '<script type="text/javascript">'
         ].join("\r\n");

    var footer =
        [
            '</script>',
            '</head>',
            '<body>',
            '<div id="aadatapanel">',
            '</div>',
            '<noscript>JavaScript Lɂĉ</noscript>',
            '</body>',
            '</html>'
         ].join("\r\n");

    var html_procs = [
        create_aadataplayer,
        create_oppanel,
        create_togglebutton,
        create_stepcount,
        create_stepspeed,
        create_loopselect,
        create_progressbar,
        create_txtpanel,
        create_datasrc
        ];

    file.WriteLine(header);

    for(i = 0; i < html_procs.length; i++) {
        file.WriteLine(html_procs[i]);
    }

    file.WriteLine("var data = " + escape_ary(data) + ";");
    file.WriteLine(footer);
}

function escape_ltgt(str)
{
    return str.replace(/</g, "&lt;").replace(/>/g, "&gt;");
}

function escape_str(str)
{
    return "\"" +
        str.replace(/[\x00-\x1f\x22\x27\x5c\x7f]/g,
                    function(s) {
                        var v = s.charCodeAt(0).toString(16);
                        return "\\x" + (v.length == 1 ? "0" + v : v); } ) +
        "\"";
}

function escape_ary(ary)
{
    var a = new Array(ary.length);
    var i;

    for(i = 0; i < ary.length; i++) {
        a[i] = escape_str(ary[i]);
    }

    return "[\r\n" + a.join(",\r\n") + "\r\n]";
}

function create_aadataplayer(data, waitfor, autostart, loop)
{
    function create() {
        var panel = document.createElement("div");
        panel.className = "aadataplayer";

        var oppanel = create_oppanel();
        oppanel.setTotalStep(data.length);
        oppanel.setCurrentStep(1);
        oppanel.setSpeed(waitfor);
        oppanel.setLoop(loop);
        panel.appendChild(oppanel);

        var txtpanel = create_txtpanel();
        panel.appendChild(txtpanel);

        var datasrc = create_datasrc(data);
        panel.appendChild(datasrc);

        txtpanel.copyContent(datasrc.getSrc(0));
        oppanel.onstepchanged = oppanel_onstepchanged;

        if(autostart) {
            oppanel.startPlay();
        }

        return panel;
    }

    function oppanel_onstepchanged(step) {
        var panel = this.parentNode;
        txtpanel(panel).copyContent(datasrc(panel).getSrc(step - 1));
    }

    function txtpanel(panel) {
        return panel.childNodes.item(1);
    }

    function datasrc(panel) {
        return panel.childNodes.item(2);
    }

    return create();
}

function create_oppanel()
{
    function create() {
        var panel = document.createElement("div");
        panel.className = "oppanel";

        var btnbar = document.createElement("div");
        btnbar.className = "buttonbar";

        var playbtn = create_togglebutton("l", "Đ/~",
                                          playbtn_onplayclick);
        btnbar.appendChild(playbtn);

        var stepcount = create_stepcount();
        stepcount.onvaluechanged = stepcount_onstepchanged;
        stepcount.onstepclick = stepcount_onstepclick;
        btnbar.appendChild(stepcount);

        var stepspeed = create_stepspeed();
        stepspeed.onvaluechanged = stepspeed_onvaluechanged;
        btnbar.appendChild(stepspeed);

        var loopselect = create_loopselect();
        loopselect.onvaluechanged = loopselect_onvaluechanged;
        btnbar.appendChild(loopselect);

        panel.appendChild(btnbar);

        var progressbar = create_progressbar();
        panel.appendChild(progressbar);

        // method
        panel.setCurrentStep = panel_setcurstep;
        panel.setTotalStep = panel_settotalstep;
        panel.setSpeed = panel_setspeed;
        panel.setLoop = panel_setloop;
        panel.stopPlay = panel_stopplay;
        panel.startPlay = panel_startplay;

        // event
        panel.onstepchanged = null;

        return panel;
    }

    function playbtn_onplayclick(btn) {
        var panel = btn.parentNode.parentNode;
        var pressed = btn.isPressed();
        panel.stopPlay();
        btn.setToggleState(false);
        if(pressed) {
            btn.setToggleState(true);
            panel.startPlay();
        }
    }

    function stepcount_onstepchanged(cur, total) {
        var panel = this.parentNode.parentNode;
        panel.setTotalStep(total);
        panel.setCurrentStep(cur);
    }

    function stepcount_onstepclick() {
        var panel = this.parentNode.parentNode;
        panel.stopPlay();
    }

    function stepspeed_onvaluechanged(speed) {
        needreset = true;
    }

    function loopselect_onvaluechanged(isloop) {
        needreset = true;
    }

    function panel_setcurstep(curstep) {
        stepcount(this).setCurrentStep(curstep);
        progressbar(this).setValue(curstep);
        invoke_onstepchanged(this, curstep);
    }

    function panel_settotalstep(totalstep) {
        stepcount(this).setTotalStep(totalstep);
        progressbar(this).setRange(1, totalstep);
    }

    function panel_setspeed(speed) {
        stepspeed(this).setSpeed(speed);
    }

    function panel_setloop(isloop) {
        loopselect(this).setLoop(isloop);
    }

    function invoke_onstepchanged(panel, curstep) {
        if(panel.onstepchanged) {
            panel.onstepchanged(curstep);
        }
    }

    var timerid = null;
    var needreset = false;

    function panel_stopplay() {
        if(! timerid) {
            return;
        }

        window.clearInterval(timerid);
        timerid = null;
        playbtn(this).setToggleState(false);
    }

    function panel_startplay() {
        if(timerid) {
            return;
        }

        if(stepcount(this).getCurrentStep() == stepcount(this).getTotalStep()) {
            stepcount(this).setCurrentStep(1);
        }

        playbtn(this).setToggleState(true);
        needreset = false;

        var panel = this;
        timerid = window.setInterval(
            function() {
                var cur = stepcount(panel).getCurrentStep();
                var total = stepcount(panel).getTotalStep();
                if(cur < total) {
                    stepcount(panel).setCurrentStep(cur + 1);
                }
                else if(loopselect(panel).getLoop()) {
                    stepcount(panel).setCurrentStep(1);
                }
                else {
                    panel.stopPlay();
                    return;
                }

                if(needreset) {
                    panel.stopPlay();
                    panel.startPlay();
                }
            }, stepspeed(this).getSpeed());
    }

    function playbtn(panel) {
        return panel.childNodes.item(0).childNodes.item(0);
    }

    function stepcount(panel) {
        return panel.childNodes.item(0).childNodes.item(1);
    }

    function stepspeed(panel) {
        return panel.childNodes.item(0).childNodes.item(2);
    }

    function loopselect(panel) {
        return panel.childNodes.item(0).childNodes.item(3);
    }

    function progressbar(panel) {
        return panel.childNodes.item(1);
    }

    return create();
}

function create_togglebutton(text, title, onclick)
{
    var ispressed = false;

    function create() {
        var btn = document.createElement("input");
        btn.type = "button";
        btn.className = "button";
        btn.value = text;
        btn.title = title;
        btn.onclick = btn_onclick;

        // method
        btn.isPressed = getstate;
        btn.setToggleState = setstate;

        return btn;
    }

    function setstate(pressed) {
        ispressed = pressed;

        if(ispressed) {
            this.className = "button pressed";
        }
        else {
            this.className = "button";
        }
    }

    function getstate() {
        return ispressed;
    }

    function btn_onclick() {
        this.setToggleState(! ispressed);
        onclick(this);
    }

    return create();
}

function create_stepcount()
{
    var current = 1;
    var total = 1;

    function create() {
        var panel = document.createElement("span");
        panel.className = "counter";

        var step = document.createElement("input");
        step.type = "text";
        step.className = "step";
        step.readOnly = true;
        panel.appendChild(step);

        panel.appendChild(create_togglebutton("||", "1R}O",
                                              prevbtn_onclick));

        panel.appendChild(create_togglebutton("||", "1R}",
                                              nextbtn_onclick));

        // method
        panel.setCurrentStep = setcurstep;
        panel.getCurrentStep = getcurstep;
        panel.setTotalStep = settotalstep;
        panel.getTotalStep = gettotalstep;

        // event
        panel.onvaluechanged = null;
        panel.onstepclick = null;

        return panel;
    }

    function prevbtn_onclick(btn) {
        var cur = current - 1;
        if(cur < 1) {
            cur = 1;
        }

        var panel = btn.parentNode;
        panel.setCurrentStep(cur);
        btn.setToggleState(false);
        invoke_onstepclick(panel);
    }

    function nextbtn_onclick(btn) {
        var cur = current + 1;
        if(cur > total) {
            cur = total;
        }

        var panel = btn.parentNode;
        panel.setCurrentStep(cur);
        btn.setToggleState(false);
        invoke_onstepclick(panel);
    }

    function setcurstep(num) {
        if(num == current) {
            return;
        }
        current = num;
        update_step(this);
        invoke_onvaluechanged(this);
    }

    function getcurstep() {
        return current;
    }

    function settotalstep(num) {
        if(num == total) {
            return;
        }
        total = num;
        update_step(this);
        invoke_onvaluechanged(this);
    }

    function gettotalstep() {
        return total;
    }

    function update_step(panel) {
        step(panel).value = current + " / " + total;
    }

    function step(panel) {
        return panel.childNodes.item(0);
    }

    function invoke_onvaluechanged(panel) {
        if(panel.onvaluechanged) {
            panel.onvaluechanged(current, total);
        }
    }

    function invoke_onstepclick(panel) {
        if(panel.onstepclick) {
            panel.onstepclick()
        }
    }

    return create();
}

function create_stepspeed()
{
    var speedmsec = 0;

    function create() {
        var panel = document.createElement("span");
        panel.className = "speed";

        var speedval = document.createElement("input");
        speedval.type = "text";
        speedval.className = "speedval";
        speedval.readOnly = true;
        panel.appendChild(speedval);

        panel.appendChild(create_togglebutton("|", "",
                                              decbtn_onclick));

        panel.appendChild(create_togglebutton("{", "x",
                                              incbtn_onclick));

        // method
        panel.setSpeed = setspeed;
        panel.getSpeed = getspeed;

        // event
        panel.onvaluechanged = null;

        return panel;
    }

    function decbtn_onclick(btn) {
        var num = speedmsec;
        num -= getrangeincval(num - 1);
        var panel = btn.parentNode;
        panel.setSpeed(num);
        btn.setToggleState(false);
    }

    function incbtn_onclick(btn) {
        var num = speedmsec;
        num += getrangeincval(num);
        var panel = btn.parentNode;
        panel.setSpeed(num);
        btn.setToggleState(false);
    }

    function setspeed(num) {
        if(num < 10) {
            num = 10;
        }

        if(num == speedmsec) {
            return;
        }
        speedmsec = num;

        if(num <= 500) {
            speedval(this).value = num + " ms";
        }
        else {
            speedval(this).value = (num / 1000).toFixed(1) + " s";
        }

        invoke_onvaluechanged(this);
    }

    function getspeed() {
        return speedmsec;
    }

    function speedval(panel) {
        return panel.childNodes.item(0);
    }

    function invoke_onvaluechanged(panel) {
        if(panel.onvaluechanged) {
            panel.onvaluechanged(speedmsec);
        }
    }

    var ranges = [
        [  100,  10 ],
        [  500,  50 ],
        [ 1500, 100 ],
        [ 5000, 500 ]
        ];
    function getrangeincval(num) {
        var i;
        for(i = 0; i < ranges.length; i++) {
            if(num < ranges[i][0]) {
                return ranges[i][1];
            }
        }
        return 1000;
    }

    return create();
}

function create_loopselect()
{
    var isloop = false;

    function create() {        
        var panel = document.createElement("span");
        panel.className = "loop";

        var check = document.createElement("input");
        check.type = "checkbox";
        check.title = "`FbNƃ[v";
        check.checked = isloop;
        check.onclick = check_onclick;
        panel.appendChild(check);

        panel.appendChild(document.createTextNode("s[g"));

        // method
        panel.setLoop = setloop;
        panel.getLoop = getloop;

        // event
        panel.onvaluechanged = null;

        return panel;
    }

    function check_onclick() {
        var panel = this.parentNode;
        panel.setLoop(this.checked);
    }

    function setloop(val) {
        if(val == isloop) {
            return;
        }
        isloop = val;
        loop(this).checked = isloop;
        invoke_onvaluechanged(this);
    }

    function getloop() {
        return isloop;
    }

    function loop(panel) {
        return panel.childNodes.item(0);
    }

    function invoke_onvaluechanged(panel) {
        if(panel.onvaluechanged) {
            panel.onvaluechanged(isloop);
        }
    }

    return create();
}

function create_progressbar()
{
    var value = 1;
    var min = 1;
    var max = 1;

    function create() {
        var panel = document.createElement("div");
        panel.className = "progressbar";

        var filler = document.createElement("div");
        filler.className = "filler";
        panel.appendChild(filler);

        // method
        panel.setValue = setvalue;
        panel.setRange = setrange;

        return panel;
    }

    function setvalue(val) {
        value = val;
        updatefiller(this);
    }

    function setrange(v1, v2) {
        min = v1;
        max = v2;
        updatefiller(this);
    }

    function getfiller(panel) {
        return panel.childNodes.item(0);
    }

    function updatefiller(panel) {
        getfiller(panel).style.width =
            (100 * (value - min) / (max - min)) + "%";
    }

    return create();
}

function create_txtpanel()
{
    function create() {
        var panel = document.createElement("div");
        panel.className = "txtpanel";

        panel.appendChild(document.createElement("div"));

        // method
        panel.copyContent = settext;

        return panel;
    }

    function settext(src) {
        this.replaceChild(src.cloneNode(true), gettext(this));
    }

    function gettext(panel) {
        return panel.childNodes.item(0);
    }

    return create();
}

function create_datasrc(data)
{
    var maxw = 0;
    var maxh = 0;

    function create() {
        var panel = document.createElement("div");
        panel.className = "datasrc";

        var i;
        for(i = 0; i < data.length; i++) {
            var d = document.createElement("div");
            d.innerHTML = data[i];
            panel.appendChild(d);

            if(d.scrollWidth > maxw) {
                maxw = d.scrollWidth;
            }
            if(d.scrollHeight > maxh) {
                maxh = d.scrollHeight;
            }
        }

        // method
        panel.getSrc = getsrc;
        panel.getMaxWidth = getmaxwidth;
        panel.getMaxHeight = getmaxheight;

        return panel;
    }

    function getsrc(idx) {
        return this.childNodes.item(idx);
    }

    function getmaxwidth() {
        return maxw;
    }

    function getmaxheight() {
        return maxh;
    }

    return create();
}
